// $Id: TmpFile.h 80 2009-10-30 18:55:50Z iisaev $
/*----------------------------------------------------------------------------------------*/
/*------------------------------------- AVALANCHE ----------------------------------------*/
/*------ Driver. Coordinates other processes, traverses conditional jumps tree.  ---------*/
/*------------------------------------- TmpFile.h ----------------------------------------*/
/*----------------------------------------------------------------------------------------*/

/*
   Copyright (C) 2009 Ildar Isaev
      iisaev@ispras.ru
   Copyright (C) 2009 Nick Lugovskoy
      lugovskoy@ispras.ru

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

#ifndef __TMP_FILE__H__
#define __TMP_FILE__H__


class TmpFile
{
public:
    TmpFile();
    
    bool good() const
    { return is_good; }

    char *getName()
    { return filename; }

    void remove();

    void print() const;

    char *exportFile()
    { is_exported = true;
      return filename;
    }

    ~TmpFile();

private:
    bool  is_exported;
    bool  is_good;
    char *filename;
    static unsigned int tmpnum;
};


#endif //__TMP_FILE__H__

